Attribute VB_Name = "FunctionsOnWRS"
'/////////////////////////////////////////////////
Public Const WRS_VER = "2.1.0"
Public Const WRS_DATE = "May 16-th, 2010"
'/////////////////////////////////////////////////
'// This module was mostly created by Iancu Andrei. Some functions used here
'// have been written by unknown authors.
'// Winamp Radio Scheduler (C) 2002-2004 Iancu Andrei, SupraSoft Romania.
'// This program is protected by international copyright laws.
'// Parts of this program and some modules are copyrighted by their
'// respective owners and have been used with their consent, for non-commercial purposes.
'//
'// Winamp Radio Scheduler (C) 2002-2010 Iancu Andrei, SupraSoft Romania.
'// This program is protected by international copyright laws.
'// Parts of this program and some modules are copyrighted by their
'// owners and have been used with their consent, for non-commercial purposes.
'//
'// You may freely distribute, compile or recompile the program and edit the sources
'// as long as you do not modify the original author's name.
'// Should you make modificatios, you should specify it in a comment at the beginning
'// of the program stating your name, e-mail and the changes / features you've added.

Public WinampProcID As Long


Public gstrKeyValue As String * 256
Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function Shell_NotifyIcon Lib "SHELL32.DLL" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Declare Function GetCurrentProcess Lib "kernel32" () As Long
Declare Function OpenProcessToken Lib "advapi32" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Declare Function LookupPrivilegeValue Lib "advapi32" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Declare Function AdjustTokenPrivileges Lib "advapi32" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFO) As Long

Public Const NIM_ADD = &H0
Public Const NIM_DELETE = &H2
Public Const NIM_MODIFY = &H1

Public Const NIF_ICON = &H2
Public Const NIF_MESSAGE = &H1
Public Const NIF_TIP = &H4

Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_MOUSEMOVE = &H200
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205

Public Const EWX_LOGOFF = 0
Public Const EWX_SHUTDOWN = 1
Public Const EWX_REBOOT = 2
Public Const EWX_FORCE = 4
Public Const TOKEN_ADJUST_PRIVILEGES = &H20
Public Const TOKEN_QUERY = &H8
Public Const SE_PRIVILEGE_ENABLED = &H2
Public Const ANYSIZE_ARRAY = 1
Public Const VER_PLATFORM_WIN32_NT = 2

Type NOTIFYICONDATA
        cbSize As Long
        hWnd As Long
        uID As Long
        uFlags As Long
        uCallbackMessage As Long
        hIcon As Long
        szTip As String * 64
End Type

Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Type LUID
    LowPart As Long
    HighPart As Long
End Type

Type LUID_AND_ATTRIBUTES
    pLuid As LUID
    Attributes As Long
End Type

Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Public IconData As NOTIFYICONDATA

Public Function ShowLog()
If FileLen(GetWinampDir & "wrs.log") > 65536 Then
    s = Shell(GetWindowsDir & "notepad.exe " & GetWinampDir & "wrs.log", vbNormalFocus)
    If s = 0 Then MsgBox "Could not launch Notepad. The log file is too large (> 64kB) to show in the log viewer window." & vbCrLf & "You'll have to open the " & GetWinampDir & "wrs.log file yourself.", vbCritical + vbApplicationModal, "WRS Log"
    Exit Function
End If
viewlog.Show
End Function

Public Function GetPath(FullFilePath As String) As String

If Len(FullFilePath) = 0 Then Exit Function

For i = 1 To Len(FullFilePath)
If Mid(FullFilePath, i, 1) = "\" Then GetPath = Left(FullFilePath, i)
Next i

If Right(GetPath, 1) <> "\" Then GetPath = GetPath & "\"


End Function
Public Function LogEvent(Mesaj As String, WentOK As Boolean)

On Error Resume Next
If Mesaj = "" Then Exit Function

trimlog1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS", "trimlog", "0")
If Val(trimlog1) = 0 Then GoTo justwrite

Dim maxsize As Long
maxsize = Val(trimlog1) * 1024

If FileLen(GetWinampDir & "wrs.log") > maxsize Then DelLine (GetWinampDir & "wrs.log")

justwrite:

Open GetWinampDir & "wrs.log" For Append As #1
    If WentOK = True Then Print #1, Format(Date, "dd mmmm yyyy") & " | " & Format(Time, "HH:mm:ss") & " | OK " & Mesaj
    If WentOK = False Then Print #1, Format(Date, "dd mmmm yyyy") & " | " & Format(Time, "HH:mm:ss") & " | FAILED " & Mesaj
Close #1

Main.mnuviewlog.Enabled = True
jingles.mnuviewlog.Enabled = True
hvr.mnuviewlog.Enabled = True

End Function
Public Function cfgwinamp()
On Error Resume Next
ceva = GetWinampDir
If Right(ceva, 1) <> "\" Then ceva = ceva & "\"

WritePrivateProfileString "Winamp", "shuffle_morph_rate", CStr("50"), ceva & "winamp.ini"
WritePrivateProfileString "Winamp", "timeleftmode", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "Winamp", "autoscrollname", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "Winamp", "outname", CStr("out_ds.dll"), ceva & "winamp.ini"

WritePrivateProfileString "out_ds", "cfg_buf_ms", CStr("20000"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_prebuf", CStr("30"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_oldpause", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_def_fade", CStr("333"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_wait", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_dev", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_sil_db", CStr("240"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_killsil", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_safe", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_gapless", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_preset", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_createprimary", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_start.Time", CStr("100"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_start.On", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_start.usedef", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_firststart.Time", CStr("100"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_firststart.On", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_firststart.usedef", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_stop.Time", CStr("1000"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_stop.On", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_stop.usedef", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_pause.Time", CStr("400"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_pause.On", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_pause.usedef", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_seek.Time", CStr("333"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_seek.On", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_fade_seek.usedef", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_slowbuffer", CStr("0"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_mixing", CStr("2"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_total_time", CStr("7206215115#"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_autocpu", CStr("1"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_status_update_freq", CStr("5000"), ceva & "winamp.ini"
WritePrivateProfileString "out_ds", "cfg_dev2", CStr("0"), ceva & "winamp.ini"

MsgBox "Winamp has been configured for use with WRS." & vbCrLf & "The crossfading plugin has now the default best performance settings.", vbInformation + vbApplicationModal, "Winamp Radio Scheduler"



End Function
Public Function IsWinNT() As Boolean

Dim myOS As OSVERSIONINFO
    myOS.dwOSVersionInfoSize = Len(myOS)
    GetVersionEx myOS
    IsWinNT = (myOS.dwPlatformId = VER_PLATFORM_WIN32_NT)

End Function
Public Function LoadJngList(FileName As String)
 
If FileExists(FileName) = False Then Exit Function
 
Open FileName For Input As #1
Line Input #1, filejng
If filejng <> "#EXTM3U" And filejng <> "#JLSLIST" And filejng <> "#HLSLIST" Then Close #1: Exit Function

tip = filejng
pos = InStrRev(FileName, "\", -1, vbTextCompare)
cale = Left(FileName, pos)
If Right(cale, 1) <> "\" Then cale = cale & "\"

jingles.List1.Clear
jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", "0")
If Val(jingles1) = 0 Then GoTo loaddirect

For i = 1 To Val(jingles1)
    DeleteValue HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & i
Next i
jingles1 = 0

loaddirect:
Do While Not EOF(1)
   Line Input #1, filejng
   If Left(filejng, 1) = "#" Then GoTo skipline
       
    If Len(Trim(filejng)) = 0 Or Trim(filejng) = "" Then GoTo skipline
    jingles1 = Val(jingles1) + 1
        
   If tip = "#EXTM3U" Then
        
        If Left(filejng, 2) = "\\" Or Right(Left(filejng, 2), 1) = ":" Then
        filejng = filejng
        End If
        
        If Left(filejng, 1) <> "\" And Right(Left(filejng, 2), 1) <> ":" Then
        filejng = cale & filejng
        End If
        
        If Left(filejng, 1) = "\" And Left(filejng, 2) <> "\\" Then
        filejng = Left(cale, 2) & filejng
        End If
    
    End If
    
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(jingles1), CStr(filejng)
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", CStr(jingles1)
    
skipline:

Loop

Close #1

UpdateJingleList
InitJngTimer

End Function
Public Function AddJngList(FileName As String)
 
If FileExists(FileName) = False Then Exit Function
 
Open FileName For Input As #1
Line Input #1, filejng
If filejng <> "#EXTM3U" And filejng <> "#JLSLIST" And filejng <> "#HLSLIST" Then Close #1: Exit Function

tip = filejng
pos = InStrRev(FileName, "\", -1, vbTextCompare)
cale = Left(FileName, pos)
If Right(cale, 1) <> "\" Then cale = cale & "\"

jingles.List1.Clear
jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", "0")

Do While Not EOF(1)
   Line Input #1, filejng
   If Left(filejng, 1) = "#" Then GoTo skipline
       
    If Len(Trim(filejng)) = 0 Or Trim(filejng) = "" Then GoTo skipline
    jingles1 = Val(jingles1) + 1
    If tip = "#EXTM3U" Then
        
        If Left(filejng, 2) = "\\" Then
        filejng = filejng
        End If
        
        If Left(filejng, 1) <> "\" Then
        filejng = cale & filejng
        End If
        
        If Left(filejng, 1) = "\" And Left(filejng, 2) <> "\\" Then
        filejng = Left(cale, 2) & filejng
        End If
    
    End If
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(jingles1), CStr(filejng)
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", CStr(jingles1)
    
skipline:

Loop

Close #1

UpdateJingleList
InitJngTimer

End Function
Public Function SaveJngList(FileName As String)

jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", "0")

If Val(jingles1) = 0 Then Exit Function
If Trim(FileName) = "" Or Len(FileName) = 0 Then Exit Function

Open FileName For Output As #1
Print #1, "#JLSLIST"

For i = 1 To Val(jingles1)
   Print #1, GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(i), "")
Next i

Close #1

End Function
Public Function SaveHVRList(FileName As String)

hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", "0")
If Val(hvr1) = 0 Then Exit Function
If Trim(FileName) = "" Or Len(FileName) = 0 Then Exit Function

Open FileName For Output As #1
Print #1, "#HLSLIST"

For i = 1 To Val(hvr1)
   Print #1, GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(i), "")
Next i

Close #1

End Function


Public Function AddHVRList(FileName As String)
 
If FileExists(FileName) = False Then Exit Function
 
Open FileName For Input As #1
Line Input #1, filejng
If filejng <> "#EXTM3U" And filejng <> "#JLSLIST" And filejng <> "#HLSLIST" Then Close #1: Exit Function

tip = filejng
pos = InStrRev(FileName, "\", -1, vbTextCompare)
cale = Left(FileName, pos)
If Right(cale, 1) <> "\" Then cale = cale & "\"

hvr.List1.Clear
hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", "0")

loaddirect1:
Do While Not EOF(1)
   Line Input #1, filehvr
   If Left(filehvr, 1) = "#" Then GoTo skipline
   hvr1 = Val(hvr1) + 1
    If tip = "#EXTM3U" Then
        
        If Left(filehvr, 2) = "\\" Then
        filehvr = filehvr
        End If
        
        If Left(filehvr, 1) <> "\" Then
        filehvr = cale & filehvr
        End If
        
        If Left(filehvr, 1) = "\" And Left(filehvr, 2) <> "\\" Then
        filehvr = Left(cale, 2) & filehvr
        End If
    
    End If
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(hvr1), CStr(filehvr)
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", CStr(hvr1)
    
skipline:

Loop

Close #1

UpdateHVRList
InitHVRTimer

End Function
Public Function LoadHVRList(FileName As String)
 
If FileExists(FileName) = False Then Exit Function
 
Open FileName For Input As #1
Line Input #1, filejng
If filejng <> "#EXTM3U" And filejng <> "#JLSLIST" And filejng <> "#HLSLIST" Then Close #1: Exit Function

tip = filejng
cale = GetPath(CStr(FileName))

hvr.List1.Clear
hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", "0")
If Val(hvr1) = 0 Then GoTo loaddirect1

For i = 1 To Val(hvr1)
    DeleteValue HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & i
Next i
hvr1 = 0

loaddirect1:
Do While Not EOF(1)
   Line Input #1, filehvr
   If Left(filehvr, 1) = "#" Then GoTo skipline
       
    If Len(Trim(filehvr)) = 0 Or Trim(filehvr) = "" Then GoTo skipline
    hvr1 = Val(hvr1) + 1

    If tip = "#EXTM3U" Then
        
        If Left(filehvr, 2) = "\\" Or Right(Left(filehvr, 2), 1) = ":" Then
        filehvr = filehvr
        End If
        
        If Left(filehvr, 1) <> "\" And Right(Left(filehvr, 2), 1) <> ":" Then
        filehvr = cale & filehvr
        End If
        
        If Left(filehvr, 1) = "\" And Left(filehvr, 2) <> "\\" Then
        filehvr = Left(cale, 2) & filehvr
        End If
    
    End If
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(hvr1), CStr(filehvr)
    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", CStr(hvr1)
    
skipline:

Loop

Close #1

UpdateHVRList
InitHVRTimer

End Function
Public Function ShutDownComp()

If IsWinNT = False Then

ret& = ExitWindowsEx(EWX_FORCE Or EWX_SHUTDOWN, 0)

Else

Dim hProc As Long
Dim hToken As Long
Dim mLUID As LUID
Dim mPriv As TOKEN_PRIVILEGES
Dim mNewPriv As TOKEN_PRIVILEGES
hProc = GetCurrentProcess()
OpenProcessToken hProc, TOKEN_ADJUST_PRIVILEGES + TOKEN_QUERY, hToken
LookupPrivilegeValue "", "SeShutdownPrivilege", mLUID
mPriv.PrivilegeCount = 1
mPriv.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
mPriv.Privileges(0).pLuid = mLUID
AdjustTokenPrivileges hToken, False, mPriv, 4 + (12 * mPriv.PrivilegeCount), mNewPriv, 4 + (12 * mNewPriv.PrivilegeCount)
Flags = EWX_SHUTDOWN + EWX_FORCE
ExitWindowsEx Flags, 0
End If

End Function

Public Function ChooseNextSong()

If hvr.Check1.Value = 0 Then
oldhvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "lastone", "1")
    
    If Val(oldhvr) >= Val(hvr.List1.ListCount) Then
        newhvr = 1
    Else
        newhvr = Val(oldhvr) + 1
    End If

If Val(hvr.List1.ListCount) = 1 Then newhvr = 1

hvr.nextsong.Caption = newhvr
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "lastone", CStr(Val(newhvr))

End If

If hvr.Check1.Value = 1 Then

redohvr:
ceva = RandomInteger(hvr.List1.ListCount)
If Val(ceva) = Val(hvr.nextsong.Caption) And Val(hvr.List1.ListCount) > 1 Then GoTo redohvr
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "lastone", CStr(Val(ceva))
hvr.nextsong.Caption = ceva

End If

End Function

Public Function ChooseNextJNG()

If jingles.Check1.Value = 0 Then
oldjng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "lastone", "1")

    If Val(oldjng) >= Val(jingles.List1.ListCount) Then
        newjng = 1
    Else
        newjng = Val(oldjng) + 1
    End If

If Val(jingles.List1.ListCount) = 1 Then newjng = 1

jingles.nextjng.Caption = newjng
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "lastone", CStr(Val(newjng))

End If

If jingles.Check1.Value = 1 Then

redoint:
ceva = RandomInteger(jingles.List1.ListCount)
If Val(ceva) = Val(jingles.nextjng.Caption) And Val(jingles.List1.ListCount) > 1 Then GoTo redoint
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "lastone", CStr(Val(ceva))
jingles.nextjng.Caption = ceva

End If

End Function

Public Function MakeTime(Seconds As Integer) As String
MakeTime = Int(Seconds / 3600) & " : " & Int((Seconds Mod 3600) / 60) & " : " & Seconds Mod 60
End Function
Public Function InitHVRTimer()

jngint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "interval", "300")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "interval", "1500")

If Val(jngint) < 180 Then jngint = 180
If Val(hvrint) < 600 Then hvrint = 600

If Val(hvrint) = Val(jngint) Then hvrint = Val(hvrint) + 10

hvr.lblhvrint.Caption = "Playing a HVR song every " & Int(Val(hvrint / 60)) & " minutes."

Main.lblhvrcnt.Caption = Format(TimeValue(MakeTime(CInt(hvrint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")


End Function

Public Function InitJngTimer()

jngint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "interval", "300")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "interval", "1500")

If Val(jngint) < 180 Then jngint = 180
If Val(hvrint) < 600 Then hvrint = 600

If Val(hvrint) = Val(jngint) Then jngint = Val(jngint) + 1

jingles.lbljingint.Caption = "Playing a jingle every " & Int(Val(jngint / 60)) & " minutes."

Main.lbljngcnt.Caption = Format(TimeValue(MakeTime(CInt(jngint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")

End Function
Public Function InitJngHVRTimers()

jngint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "interval", "300")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "interval", "1500")

If Val(jngint) > 32766 Then
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "interval", CStr(Val(3) * 60)
jngint = 180
End If

If Val(hvrint) > 32766 Then
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "interval", CStr(Val(60) * 60)
hvrint = 3600
End If


'If Val(jngint) < 180 Then jngint = 180
'If Val(hvrint) < 600 Then hvrint = 600

If Val(hvrint) = Val(jngint) Then hvrint = Val(hvrint) + 10

jingles.lbljingint.Caption = "Playing a jingle every " & Int(Val(jngint / 60)) & " minutes."
hvr.lblhvrint.Caption = "Playing a HVR song every " & Int(Val(hvrint / 60)) & " minutes."



Main.lbljngcnt.Caption = Format(TimeValue(MakeTime(CInt(jngint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")
Main.lblhvrcnt.Caption = Format(TimeValue(MakeTime(CInt(hvrint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")

End Function

Public Function UpdateTimerLabels(JobCountdown As String, JngCountdown As String, HVRCountdown As String)

Main.lblothertimers.Caption = "Running next Jingle in : " & JngCountdown & "  | Running next HVR Song in : " & HVRCountdown
jingles.lblothertimers.Caption = "Running next Job in : " & JobCountdown & "  | Running next HVR Song in : " & HVRCountdown
hvr.lblothertimers.Caption = "Running next Job in : " & JobCountdown & "  | Running next Jingle in : " & JngCountdown

End Function

Public Function StartJobs()

'porneste joburile
Main.Command3.Caption = "Jobs : ON"
jingles.Command3.Caption = "Jobs : ON"
hvr.Command3.Caption = "Jobs : ON"
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs", "enabled", "yes"
Main.enabjobs.Caption = ""
UpdateJobStatus

End Function
Public Function UpdateHVRList()

hvr.List1.Clear

hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", "0")
For i = 1 To Val(hvr1)
    filehvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(i), "")
    If Trim(filehvr) = "" Then GoTo skiphvr
    If Len(filehvr) > 52 Then filehvr = Left(filehvr, 3) & "..." & Right(filehvr, 46)
    itm = CStr(i) & ". " & filehvr
    hvr.List1.AddItem itm
skiphvr:
Next i

End Function
Public Function InitJngHVR()

editjnghvr.Label1.Caption = ""
editjnghvr.Label2.Caption = ""
editjnghvr.no.Caption = ""
editjnghvr.jnghvr.Caption = ""
editjnghvr.Text1.Text = ""
editjnghvr.Text2.Text = ""
editjnghvr.Caption = ""

End Function
Public Function UpdateJingleList()

jingles.List1.Clear

jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", "0")
For i = 1 To Val(jingles1)
    filejng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(i), "")
    If Trim(filejng) = "" Then GoTo skipjng
    If Len(filejng) > 52 Then filejng = Left(filejng, 3) & "..." & Right(filejng, 46)
    itm = CStr(i) & ". " & filejng
    jingles.List1.AddItem itm
skipjng:
Next i

End Function
Public Function StartJingles()

jingles.enabjingles.Caption = ""
Main.Command4.Caption = "Jingles : ON"
jingles.Command4.Caption = "Jingles : ON"
hvr.Command4.Caption = "Jingles : ON"
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "enabled", "yes"
InitJngTimer
UpdateJobStatus

End Function
Public Function StopJingles()

jingles.enabjingles.Caption = "stop"
Main.Command4.Caption = "Jingles : OFF"
jingles.Command4.Caption = "Jingles : OFF"
hvr.Command4.Caption = "Jingles : OFF"
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "enabled", "no"
UpdateJobStatus

End Function
Public Function StartHVR()

hvr.enabhvr.Caption = ""
Main.Command5.Caption = "HVR : ON"
jingles.Command5.Caption = "HVR : ON"
hvr.Command5.Caption = "HVR : ON"
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\\HVRSongs", "enabled", "yes"
InitHVRTimer
UpdateJobStatus

End Function
Public Function StopHVR()

hvr.enabhvr.Caption = "stop"
Main.Command5.Caption = "HVR : OFF"
jingles.Command5.Caption = "HVR : OFF"
hvr.Command5.Caption = "HVR : OFF"
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "enabled", "no"
UpdateJobStatus

End Function
Public Function UpdatePlay(Mesaj As String)
    
    Main.lblplay.Caption = Mesaj
    jingles.lblplay.Caption = Mesaj
    hvr.lblplay.Caption = Mesaj
    
End Function
Public Function UpdateJobStatus()

If Main.enabjobs.Caption = "stop" Then ceva1 = "OFF"
If Main.enabjobs.Caption = "" Then ceva1 = "ON"

If jingles.enabjingles.Caption = "stop" Then ceva2 = "OFF"
If jingles.enabjingles.Caption = "" Then ceva2 = "ON"

If hvr.enabhvr.Caption = "stop" Then ceva3 = "OFF"
If hvr.enabhvr.Caption = "" Then ceva3 = "ON"


If ceva1 = "ON" Or ceva2 = "ON" Or ceva3 = "ON" Then
Main.lbljobstatus.ForeColor = &HC0&
jingles.lbljobstatus.ForeColor = &HC0&
hvr.lbljobstatus.ForeColor = &HC0&
Main.mnudis.Caption = "&Disable Scheduler"
Else
Main.lbljobstatus.ForeColor = &H0&
jingles.lbljobstatus.ForeColor = &H0&
hvr.lbljobstatus.ForeColor = &H0&
Main.mnudis.Caption = "&Enable Scheduler"
End If

Main.lbljobstatus.Caption = "Jobs: " & ceva1 & " | Jingles: " & ceva2 & " | Heavy Rotation: " & ceva3
jingles.lbljobstatus.Caption = "Jobs: " & ceva1 & " | Jingles: " & ceva2 & " | Heavy Rotation: " & ceva3
hvr.lbljobstatus.Caption = "Jobs: " & ceva1 & " | Jingles: " & ceva2 & " | Heavy Rotation: " & ceva3

End Function
Public Function DelLine(FileName As String)

Name FileName As FileName & ".tmp"

Open FileName & ".tmp" For Input As #1
Open FileName For Output As #2

i = 1

Do While Not EOF(1)
    Line Input #1, linie
    If i > 1 Then Print #2, linie
    i = i + 1
Loop

Close #1
Close #2

Kill FileName & ".tmp"

End Function

Public Function DelHVR(ListIndex As Integer)

hvrs = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", "0")
If Val(hvrs) = 0 Then Exit Function

If ListIndex + 1 = hvrs Then GoTo dirdelete
For i = ListIndex + 1 To hvrs - 1

ceva = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(Val(i + 1)), "")

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(Val(i)), CStr(ceva)

Next i

dirdelete:

DeleteValue HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "song" & CStr(hvrs)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "songno", CStr(Val(hvrs - 1))

End Function
Public Function DelJng(ListIndex As Integer)

jings = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", "0")
If Val(jings) = 0 Then Exit Function

If ListIndex + 1 = jings Then GoTo directdelete
For i = ListIndex + 1 To jings - 1

ceva = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(Val(i + 1)), "")

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(Val(i)), CStr(ceva)

Next i

directdelete:
DeleteValue HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jng" & CStr(jings)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "jngno", CStr(Val(jings - 1))

End Function

Public Function UpdatePos(Mesaj As String)
    
    Main.lblpos.Caption = Mesaj
    jingles.lblpos.Caption = Mesaj
    hvr.lblpos.Caption = Mesaj
    
End Function

Public Function StopJobs()

'opreste joburile
Main.Command3.Caption = "Jobs : OFF"
jingles.Command3.Caption = "Jobs : OFF"
hvr.Command3.Caption = "Jobs : OFF"
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs", "enabled", "no"
Main.enabjobs.Caption = "stop"
UpdateJobStatus

End Function
Public Function LoadJobs(FileName As String) As Boolean
If FileName = "" Then Exit Function

nojobs = ReadFromIniFile(FileName, "wrs_jobs", "saved", 0)
If nojobs = 0 Then MsgBox "This file contains no WRS jobs. If this is a *.JOB file, it may be corrupt.", vbCritical + vbApplicationModal, "Import job(s)": Exit Function

For i = 1 To nojobs

jobname = ReadFromIniFile(FileName, "job" & i, "jobname", "Job " & i)
jobdate = ReadFromIniFile(FileName, "job" & i, "jobdate", CStr(Format(Date, "dd mmmm yyyy")))
jobtime = ReadFromIniFile(FileName, "job" & i, "jobtime", CStr(Format(Time, "HH:mm:ss")))

washuffle = ReadFromIniFile(FileName, "job" & i, "washuffle", "on")
warepeat = ReadFromIniFile(FileName, "job" & i, "warepeat", "on")
waclear = ReadFromIniFile(FileName, "job" & i, "waclear", "on")
jingles1 = ReadFromIniFile(FileName, "job" & i, "jingles", "on")
hvr1 = ReadFromIniFile(FileName, "job" & i, "hvr", "on")
cuejng = ReadFromIniFile(FileName, "job" & i, "cuejng", "on")
cuehvr = ReadFromIniFile(FileName, "job" & i, "cuehvr", "on")
shufjng = ReadFromIniFile(FileName, "job" & i, "shufjng", "on")
shufhvr = ReadFromIniFile(FileName, "job" & i, "shufhvr", "on")
live = ReadFromIniFile(FileName, "job" & i, "live", "off")
cuejob = ReadFromIniFile(FileName, "job" & i, "cuejob", "on")
shutdown = ReadFromIniFile(FileName, "job" & i, "shutdown", "off")

jingleint = ReadFromIniFile(FileName, "job" & i, "jingleint", "5")
hvrint = ReadFromIniFile(FileName, "job" & i, "hvrint", "20")
 
wafile = ReadFromIniFile(FileName, "job" & i, "wafile", "0")
walist = ReadFromIniFile(FileName, "job" & i, "walist", "0")
jnglist = ReadFromIniFile(FileName, "job" & i, "jnglist", "0")
hvrlist = ReadFromIniFile(FileName, "job" & i, "hvrlist", "0")

j = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs", "jobno", "0")
j = j + 1

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "jobname", CStr(jobname)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "jobdate", CStr(jobdate)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "jobtime", CStr(jobtime)

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "washuffle", CStr(washuffle)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "warepeat", CStr(warepeat)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "waclear", CStr(waclear)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "jingles", CStr(jingles1)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "hvr", CStr(hvr1)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "cuejng", CStr(cuejng)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "cuehvr", CStr(cuehvr)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "shufjng", CStr(shufjng)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "shufhvr", CStr(shufhvr)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "live", CStr(live)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "cuejob", CStr(cuejob)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "shutdown", CStr(shutdown)

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "jingleint", CStr(jingleint)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "hvrint", CStr(hvrint)
 
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "wafile", CStr(wafile)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "walist", CStr(walist)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "jnglist", CStr(jnglist)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & j, "hvrlist", CStr(hvrlist)

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs", "jobno", CStr(j)

Next i

LoadJobs = True
MsgBox "Succesfully added " & nojobs & " job(s) to WRS", vbInformation + vbApplicationModal, "Import job(s)"

ResetMain

End Function

Public Function SaveJob(FileName As String, contor As Integer, jobno As Integer) As Boolean

If FileName = "" Then Exit Function
If contor = 0 Or jobno = 0 Then Exit Function

i = jobno

jobname = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobname", "Job " & i)
jobdate = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobdate", CStr(Format(Date, "dd mmmm yyyy")))
jobtime = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobtime", CStr(Format(Time, "HH:mm:ss")))

washuffle = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "washuffle", "on")
warepeat = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "warepeat", "on")
waclear = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "waclear", "on")
jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingles", "on")
hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvr", "on")
cuejng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejng", "on")
cuehvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuehvr", "on")
shufjng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufjng", "on")
shufhvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufhvr", "on")
live = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "live", "off")
cuejob = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejob", "on")
shutdown = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shutdown", "off")

jingleint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingleint", "5")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrint", "20")
 
wafile = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "wafile", "0")
walist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "walist", "0")
jnglist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jnglist", "0")
hvrlist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrlist", "0")


i = contor

WriteToIniFile FileName, "wrs_jobs", "saved", i
WriteToIniFile FileName, "job" & i, "jobname", CStr(jobname)
WriteToIniFile FileName, "job" & i, "jobdate", CStr(jobdate)
WriteToIniFile FileName, "job" & i, "jobtime", CStr(jobtime)

WriteToIniFile FileName, "job" & i, "washuffle", CStr(washuffle)
WriteToIniFile FileName, "job" & i, "warepeat", CStr(warepeat)
WriteToIniFile FileName, "job" & i, "waclear", CStr(waclear)
WriteToIniFile FileName, "job" & i, "jingles", CStr(jingles1)
WriteToIniFile FileName, "job" & i, "hvr", CStr(hvr1)
WriteToIniFile FileName, "job" & i, "cuejng", CStr(cuejng)
WriteToIniFile FileName, "job" & i, "cuehvr", CStr(cuehvr)
WriteToIniFile FileName, "job" & i, "shufjng", CStr(shufjng)
WriteToIniFile FileName, "job" & i, "shufhvr", CStr(shufhvr)
WriteToIniFile FileName, "job" & i, "live", CStr(live)
WriteToIniFile FileName, "job" & i, "cuejob", CStr(cuejob)
WriteToIniFile FileName, "job" & i, "shutdown", CStr(shutdown)

WriteToIniFile FileName, "job" & i, "jingleint", CStr(jingleint)
WriteToIniFile FileName, "job" & i, "hvrint", CStr(hvrint)
 
WriteToIniFile FileName, "job" & i, "wafile", CStr(wafile)
WriteToIniFile FileName, "job" & i, "walist", CStr(walist)
WriteToIniFile FileName, "job" & i, "jnglist", CStr(jnglist)
WriteToIniFile FileName, "job" & i, "hvrlist", CStr(hvrlist)

SaveJob = True
End Function

Public Function InitJobEdit()

jobedit.washuffle.Value = 0
jobedit.warepeat.Value = 0
jobedit.jingles.Value = 0
jobedit.hvr.Value = 0
jobedit.cuejng.Value = 0
jobedit.cuehvr.Value = 0
jobedit.shufjng.Value = 0
jobedit.shufhvr.Value = 0
jobedit.live.Value = 0
jobedit.cuejob.Value = 0
jobedit.shutdown.Value = 0
jobedit.jingleint.Value = 0
jobedit.hvrint.Value = 0
jobedit.wafile.Value = 0
jobedit.walist.Value = 0
jobedit.jnglist.Value = 0
jobedit.hvrlist.Value = 0

jobedit.txtjobname.Text = ""
jobedit.txtjingleint.Text = ""
jobedit.txthvrint.Text = ""
jobedit.txtwafile.Text = ""
jobedit.txtwalist.Text = ""
jobedit.txtjnglist.Text = ""
jobedit.txthvrlist.Text = ""


jobedit.labeldate.Caption = ""
jobedit.labeltime.Caption = ""
jobedit.jobno.Caption = ""

jobedit.txtjingleint.ForeColor = &H0&
jobedit.txthvrint.ForeColor = &H0&
jobedit.txtwafile.ForeColor = &H0&
jobedit.txtwalist.ForeColor = &H0&
jobedit.txtjnglist.ForeColor = &H0&
jobedit.txthvrlist.ForeColor = &H0&

End Function
Public Function DelJob(ListIndex As Integer)

If ListIndex < 0 Then Exit Function
jobs = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs", "jobno", "0")

If Val(jobs) = 0 Then Exit Function

If Val(ListIndex + 1) = Val(jobs) Then GoTo deletedirect


For i = Val(ListIndex + 1) To Val(jobs - 1)

'citeste job-ul urmator
i = i + 1

'///
jobname = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobname", "Job " & i)
jobdate = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobdate", CStr(Format(Date, "dd mmmm yyyy")))
jobtime = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobtime", CStr(Format(Time, "HH:mm:ss")))

washuffle = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "washuffle", "on")
warepeat = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "warepeat", "on")
waclear = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "waclear", "on")
jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingles", "on")
hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvr", "on")
cuejng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejng", "on")
cuehvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuehvr", "on")
shufjng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufjng", "on")
shufhvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufhvr", "on")
live = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "live", "off")
cuejob = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejob", "on")
shutdown = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shutdown", "off")

jingleint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingleint", "5")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrint", "20")
 
wafile = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "wafile", "0")
walist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "walist", "0")
jnglist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jnglist", "0")
hvrlist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrlist", "0")
'///
i = i - 1
'////
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobname", CStr(jobname)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobdate", CStr(jobdate)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobtime", CStr(jobtime)

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "washuffle", CStr(washuffle)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "warepeat", CStr(warepeat)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "waclear", CStr(waclear)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingles", CStr(jingles1)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvr", CStr(hvr1)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejng", CStr(cuejng)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuehvr", CStr(cuehvr)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufjng", CStr(shufjng)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufhvr", CStr(shufhvr)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "live", CStr(live)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejob", CStr(cuejob)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shutdown", CStr(shutdown)

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingleint", CStr(jingleint)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrint", CStr(hvrint)
 
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "wafile", CStr(wafile)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "walist", CStr(walist)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jnglist", CStr(jnglist)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrlist", CStr(hvrlist)
'////

Next i

deletedirect:

DeleteKey HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & jobs
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs", "jobno", CStr(Val(Val(jobs) - 1))

End Function
Public Function ResetMain()

Main.reset.Caption = "reset"

End Function
Public Function JobDay(jobdate As String) As String

If Left(jobdate, 1) <> "w" Then Exit Function
JobDay = LCase(Trim(Mid(jobdate, 2, Len(jobdate))))

End Function
Public Function JobDays(jobdate As String, Optional strlength As Integer = 100) As String

JobDays = JobDay(CStr(jobdate))
JobDays = Replace(JobDays, " ", ", ")
If Len(JobDays) > strlength Then JobDays = Left(JobDays, strlength) & "..."
    
End Function
Public Function FirstCap(Sir As String) As String

Sir = CStr(Sir)
FirstCap = UCase(Left(Sir, 1)) & Mid(Sir, 2, Len(Sir) - 1)

End Function
Public Function GetWeekdays(Optional Cand As Date)

'If IsDate(Cand) = False Then Exit Function
'da = Format(Date, "dd mmmm yyyy", vbUseSystemDayOfWeek, vbUseSystem)
'If i = 1 Then datetime.Combo1.Text = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 1, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check2.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 2, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check2.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 3, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check3.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 4, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check4.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 5, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check5.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 6, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check6.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 7, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check7.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

da = DateAdd("w", 8, Format(Date, "dd mm yyyy", vbUseSystemDayOfWeek, vbUseSystem))
datetime.Check1.Caption = UCase(Left(Format(da, "dddd"), 1)) & Right(Format(da, "dddd"), Val(Len(Format(da, "dddd"))) - 1)

'Next i

End Function
Public Function GetWindowsDir() As String

Dim sDir As String * 255
Dim iReturn As Integer
Dim lSize As Long
     
sDir = Space$(255)
lSize = Len(sDir)
iReturn = GetWindowsDirectory(sDir, lSize)
    
GetWindowsDir = Left$(sDir, InStr(1, sDir, Chr$(0)) - 1)
If Right(GetWindowsDir, 1) <> "\" Then GetWindowsDir = GetWindowsDir & "\"

End Function
Public Function GetSystemDir() As String

Dim sDir As String * 255
Dim iReturn As Integer
Dim lSize As Long
     
sDir = Space$(255)
lSize = Len(sDir)
iReturn = GetSystemDirectory(sDir, lSize)

GetSystemDir = Left$(sDir, InStr(1, sDir, Chr$(0)) - 1)
If Right(GetSystemDir, 1) <> "\" Then GetSystemDir = GetSystemDir & "\"

End Function
Public Function RandomInteger(ValMax As Long) As Integer

Randomize

If ValMax <= 1 Then
   RandomInteger = 1
Else
   Randomize
   RandomInteger = Int((ValMax * Rnd) + 1)
End If

End Function
Public Function RunJob(jobno As Integer, Optional NoWAFile As Boolean = False) As Boolean

If jobno < 0 Then Exit Function
i = jobno

jobdate = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobdate", "d")

washuffle = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "washuffle", "on")
warepeat = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "warepeat", "on")
waclear = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "waclear", "on")
jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingles", "on")
hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvr", "on")
cuejng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejng", "on")
cuehvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuehvr", "on")
shufjng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufjng", "on")
shufhvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufhvr", "on")
live = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "live", "off")
cuejob = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejob", "on")
shutdown = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shutdown", "off")

jingleint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingleint", "5")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrint", "20")
 
wafile = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "wafile", "0")
walist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "walist", "0")
jnglist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jnglist", "0")
hvrlist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrlist", "0")

If LCase(shutdown) = "on" Then
StopWinamp
Main.silencedet.Caption = ""
Main.autostart.Caption = ""
If Main.Command12.Enabled = True And jingles.Command12.Enabled = True And hvr.Command12.Enabled = True Then StopLiveFeed: Wait (100)
Main.tmrshutdown.Interval = 100
Main.lbltimer.Caption = ""
Main.lbltimer.Visible = True
Main.tmrshutdown.Enabled = True
Exit Function
End If

If LCase(live) = "on" Then

If jingles.enabjingles.Caption = "stop" Then ceva2 = "OFF"
If jingles.enabjingles.Caption = "" Then ceva2 = "ON"

If hvr.enabhvr.Caption = "stop" Then ceva3 = "OFF"
If hvr.enabhvr.Caption = "" Then ceva3 = "ON"

SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS", "jngstat", LCase(ceva2)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS", "hvrstat", LCase(ceva3)

StopJingles
StopHVR

Main.Command12.Enabled = True
jingles.Command12.Enabled = True
hvr.Command12.Enabled = True

jingles.Command4.Enabled = False
jingles.Command5.Enabled = False
jingles.Command6.Enabled = False
 
hvr.Command4.Enabled = False
hvr.Command5.Enabled = False
hvr.Command6.Enabled = False

Main.Command4.Enabled = False
Main.Command5.Enabled = False

WritePlayList
Wait (100)
ClearPlaylist
Wait (50)
AddToPlaylist (wafile)
Wait (100)
Play
RunJob = True
Exit Function
End If

If LCase(washuffle) = "on" Then
ShuffleON
Else
ShuffleOFF
End If

If LCase(warepeat) = "on" Then
RepeatON
Else
RepeatOFF
End If

If LCase(jingles1) = "on" Then
    StartJingles
Else
    StopJingles
End If

If LCase(hvr1) = "on" Then
    StartHVR
Else
    StopHVR
End If

If LCase(cuejng) = "on" Then
    jingles.Check2.Value = 1
Else
    jingles.Check2.Value = 0
End If

If LCase(cuehvr) = "on" Then
    hvr.Check2.Value = 1
Else
    hvr.Check2.Value = 0
End If

If LCase(shufjng) = "on" Then
    jingles.Check1.Value = 1
Else
    jingles.Check1.Value = 0
End If

If LCase(shufhvr) = "on" Then
    hvr.Check1.Value = 1
Else
    hvr.Check1.Value = 0
End If

If Val(jingleint) > 0 Then
hvrint2 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "interval", "1500")
If Val(hvrint2) = Val(jingleint) * 60 Then jingleint = Val(jingleint) + 3
jingleint = Val(jingleint) * 60
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "interval", CStr(Val(jingleint))
InitJngTimer
End If

If Val(hvrint) > 0 Then
jngint2 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jingles", "interval", "300")
If Val(jngint2) = Val(hvrint) * 60 Then hvrint = Val(hvrint) + 3
hvrint = Val(hvrint) * 60
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\HVRSongs", "interval", CStr(Val(hvrint))
InitHVRTimer
End If


If NoWAFile = True Then GoTo setlist

If LCase(waclear) = "on" Then ClearPlaylist

If wafile > "0" Then
    AddToPlaylist (wafile)
    
    If LCase(waclear) = "on" Or Val(GetPlayStatus) <> 1 Then
       Play
    End If
    
    

End If

setlist:

If walist > "0" Then
    
    If LCase(waclear) = "on" Then
        Wait (100)
        ClearPlaylist
    End If
    
    AddToPlaylist (walist)

End If

If jnglist > "0" Then
    LoadJngList (jnglist)
End If

If hvrlist > "0" Then
    LoadHVRList (hvrlist)
End If

nodelete1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS", "nodelete", "no")
If LCase(nodelete1) = "no" Then If Left(jobdate, 1) <> "d" And Left(jobdate, 1) <> "w" Then DelJob (jobno - 1)

RunJob = True

End Function
Public Function StopLiveFeed()
jngstat = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS", "jngstat", "on")
hvrstat = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS", "hvrstat", "on")

If jngstat = "on" Then StartJingles
If hvrstat = "on" Then StartHVR

Main.Command12.Enabled = False
jingles.Command12.Enabled = False
hvr.Command12.Enabled = False

jingles.Command4.Enabled = True
jingles.Command5.Enabled = True
jingles.Command6.Enabled = True
 
hvr.Command4.Enabled = True
hvr.Command5.Enabled = True
hvr.Command6.Enabled = True

Main.Command4.Enabled = True
Main.Command5.Enabled = True
End Function
Public Function EditJob(ListIndex As Integer)

If ListIndex < 0 Then Exit Function
i = ListIndex + 1

'modifica job-ul numarul listindex + 1

jobname = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobname", "Job " & i)
jobdate = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobdate", CStr(Format(Date, "dd mmmm yyyy")))
jobtime = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jobtime", CStr(Format(Time, "HH:mm:ss")))

washuffle = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "washuffle", "on")
warepeat = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "warepeat", "on")
waclear = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "waclear", "on")

jingles1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingles", "on")
hvr1 = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvr", "on")
cuejng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejng", "on")
cuehvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuehvr", "on")
shufjng = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufjng", "on")
shufhvr = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shufhvr", "on")
live = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "live", "off")
cuejob = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "cuejob", "on")
shutdown = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "shutdown", "off")

jingleint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jingleint", "5")
hvrint = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrint", "20")
 
wafile = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "wafile", "0")
walist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "walist", "0")
jnglist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "jnglist", "0")
hvrlist = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\Jobs\Job" & i, "hvrlist", "0")

InitJobEdit

jobedit.jobno.Caption = i
jobedit.txtjobname.Text = jobname
jobedit.labeldate.Caption = jobdate
jobedit.labeltime.Caption = jobtime


If LCase(washuffle) = "on" Then
    jobedit.washuffle.Value = 1
Else
    jobedit.washuffle.Value = 0
End If

If LCase(warepeat) = "on" Then
    jobedit.warepeat.Value = 1
Else
    jobedit.warepeat.Value = 0
End If

If LCase(waclear) = "on" Then
    jobedit.waclear.Value = 1
Else
    jobedit.waclear.Value = 0
End If

If LCase(jingles1) = "on" Then
    jobedit.jingles.Value = 1
Else
    jobedit.jingles.Value = 0
End If

If LCase(hvr1) = "on" Then
    jobedit.hvr.Value = 1
Else
    jobedit.hvr.Value = 0
End If

If LCase(cuejng) = "on" Then
    jobedit.cuejng.Value = 1
Else
    jobedit.cuejng.Value = 0
End If

If LCase(cuehvr) = "on" Then
    jobedit.cuehvr.Value = 1
Else
    jobedit.cuehvr.Value = 0
End If

If LCase(shufjng) = "on" Then
    jobedit.shufjng.Value = 1
Else
    jobedit.shufjng.Value = 0
End If

If LCase(shufhvr) = "on" Then
    jobedit.shufhvr.Value = 1
Else
    jobedit.shufhvr.Value = 0
End If

If LCase(live) = "on" Then
    jobedit.live.Value = 1
Else
    jobedit.live.Value = 0
End If

If LCase(cuejob) = "on" Then
    jobedit.cuejob.Value = 1
Else
    jobedit.cuejob.Value = 0
End If

If LCase(shutdown) = "on" Then
    jobedit.shutdown.Value = 1
Else
    jobedit.shutdown.Value = 0
End If

If Val(jingleint) > 0 Then
    jobedit.txtjingleint.Text = jingleint
    jobedit.jingleint.Value = 1
Else
    jobedit.txtjingleint.Text = ""
    jobedit.jingleint.Value = 0
End If

If Val(hvrint) > 0 Then
    jobedit.txthvrint.Text = hvrint
    jobedit.hvrint.Value = 1
Else
    jobedit.txthvrint.Text = ""
    jobedit.hvrint.Value = 0
End If

If wafile > "0" Then
    jobedit.txtwafile.Text = wafile
    jobedit.wafile.Value = 1
    jobedit.Command2.Enabled = True
Else
    jobedit.txtwafile.Text = ""
    jobedit.wafile.Value = 0
    jobedit.Command2.Enabled = False
End If

If walist > "0" Then
    jobedit.txtwalist.Text = walist
    jobedit.walist.Value = 1
    jobedit.Command3.Enabled = True
Else
    jobedit.txtwalist.Text = ""
    jobedit.walist.Value = 0
    jobedit.Command3.Enabled = False
End If

If jnglist > "0" Then
    jobedit.txtjnglist.Text = jnglist
    jobedit.jnglist.Value = 1
    jobedit.Command4.Enabled = True
Else
    jobedit.txtjnglist.Text = ""
    jobedit.jnglist.Value = 0
    jobedit.Command4.Enabled = False
End If

If hvrlist > "0" Then
    jobedit.txthvrlist.Text = hvrlist
    jobedit.hvrlist.Value = 1
    jobedit.Command5.Enabled = True
Else
    jobedit.txthvrlist.Text = ""
    jobedit.hvrlist.Value = 0
    jobedit.Command5.Enabled = False
End If

If LCase(live) = "on" Then jobedit.Command2.Enabled = False

jobedit.Top = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\WindowPosition", "TopJobEdit", Main.Top + (Main.Height - jobedit.Height) / 2)
jobedit.Left = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\WindowPosition", "LeftJobEdit", Main.Left + (Main.Width - jobedit.Width) / 2)

jobedit.Caption = "Editing Job " & jobedit.jobno.Caption

If Left(jobdate, 1) = "d" Then jobedit.lbldatetime.Caption = "Running daily at " & Format(TimeValue(jobtime), "HH:mm:ss")
If Left(jobdate, 1) = "w" Then jobedit.lbldatetime.Caption = "Running every " & JobDays(CStr(jobdate), 25) & " at " & Format(TimeValue(jobtime), "HH:mm:ss")
If IsDate(jobdate) = True Then jobedit.lbldatetime.Caption = "Running on " & Format(CDate(jobdate), "dddd, dd mmmm yyyy") & " at " & Format(TimeValue(jobtime), "HH:mm:ss")

jobedit.Show 1

End Function
Public Function FileExists(ByVal FileName As String) As Boolean
    
Dim FileInfo As Variant

FileExists = True
On Error Resume Next
FileInfo = FileDateTime(FileName)
    
Select Case err
       Case 53, 76, 68
              FileExists = False
            err = 0
       Case Else
            If err <> 0 Then
            'error !
            End If
End Select
  
End Function
Public Function StopRun()

Main.Label3.Visible = False
Main.Label4.Visible = False
Main.Label3.Caption = ""
Main.Label4.Caption = ""


jingles.Label3.Visible = False
jingles.Label4.Visible = False
jingles.Label3.Caption = ""
jingles.Label4.Caption = ""

hvr.Label3.Visible = False
hvr.Label4.Visible = False
hvr.Label3.Caption = ""
hvr.Label4.Caption = ""

End Function
Public Function DelLst(ListIndex As Integer)

lists = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\QuickLists", "lstno", "0")
If Val(lists) = 0 Then Exit Function

If ListIndex + 1 = lists Then GoTo directdelete

For i = ListIndex + 1 To lists - 1

    ceva = GetSettingString(HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\QuickLists", "lst" & CStr(Val(i + 1)), "")

    SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\QuickLists", "lst" & CStr(Val(i)), CStr(ceva)

Next i

directdelete:
DeleteValue HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\QuickLists", "lst" & CStr(lists)
SaveSettingString HKEY_LOCAL_MACHINE, "SOFTWARE\VisionSoftware\WRS\QuickLists", "lstno", CStr(Val(lists - 1))

End Function

Public Function RunJngHVR(FileName As String) As Boolean

RunJngHVR = False

If FileExists(FileName) = False Then Exit Function

p = 0
redo1:
WritePlayList
p = p + 1
If p = 6 Then
    InitHVRTimer
    UpdateHVRList
    Exit Function
End If
If FileExists(GetWinampDir & "winamp.m3u") = False Then Wait (500): GoTo redo1

Do Until GetPlayListLength = 0
    ClearPlaylist
    Wait (10)
Loop

Wait (100)
ClearPlaylist

Wait (100)
AddToPlaylist (FileName)
Play
Wait (100)
Do Until GetPlayListLength = 0
    ClearPlaylist
    Wait (10)
Loop
Wait (100)
AddToPlaylist (GetWinampDir & "winamp.m3u")
RunJngHVR = True

End Function
Public Function GetWinampDir() As String

GetWinampDir = GetSettingString(HKEY_CLASSES_ROOT, "Winamp.SkinZip\shell\install\command", "")
GetWinampDir = Left(GetWinampDir, Len(GetWinampDir) - 17)
GetWinampDir = Right(GetWinampDir, Len(GetWinampDir) - 1)
If Right(GetWinampDir, 1) <> "\" Then GetWinampDir = GetWinampDir & "\"

End Function
Public Function DebugHVR(Seconds As Integer)

hvrint = Seconds
Main.lblhvrcnt.Caption = Format(TimeValue(MakeTime(CInt(hvrint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")
Main.lbljngcnt.Caption = Format(TimeValue(MakeTime(CInt(jngint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")


End Function
Public Function DebugJNG(Seconds As Integer)

jngint = Seconds
Main.lbljngcnt.Caption = Format(TimeValue(MakeTime(CInt(jngint))) + TimeValue(Format(Time, "HH:mm:ss")), "HH:mm:ss")


End Function

Public Function Wait(MiliSeconds As Double)

   Dim MyTime As Double
   MyTime = Timer
   Do Until Timer > MyTime + (MiliSeconds / 1000)
      DoEvents
   Loop
    
End Function

