Attribute VB_Name = "IniFiles"
'//
'// Winamp Radio Scheduler (C) 2002-2004 Iancu Andrei, SupraSoft Romania.
'// This program is protected by international copyright laws.
'// Parts of this program and some modules are copyrighted by their
'// owners and have been used with their consent, for non-commercial purposes.
'//
'// You may freely distribute, compile or recompile the program and edit the sources
'// as long as you do not modify the original author's name.
'// Should you make modificatios, you should specify it in a comment at the beginning
'// of the program stating your name, e-mail and the changes / features you've added.

Option Explicit
Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" _
    (ByVal lpApplicationName As String, _
     ByVal lpKeyName As String, _
     ByVal lpString As String, _
     ByVal lpFileName As String) As Long

Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" _
    (ByVal lpApplicationName As String, _
     ByVal lpKeyName As Any, _
     ByVal lpDefault As String, _
     ByVal lpReturnedString As String, _
     ByVal nSize As Long, _
     ByVal lpFileName As String) As Long

Function WriteToIniFile( _
   ByVal strFileName As String, _
   ByVal strSection As String, _
   ByVal strKey As String, _
   ByVal strValue As String _
   ) As Boolean
    
If WritePrivateProfileString(strSection, strKey, _
            strValue, strFileName) Then
        WriteToIniFile = True
Else
        MsgBox "Error writing to .ini file: " & err.LastDllError
        WriteToIniFile = False
End If
    
End Function

Function DeleteIniSection( _
   strSection As String, _
   strFileName As String _
   ) As Boolean
    
If WritePrivateProfileString(strSection, vbNullString, _
            vbNullString, strFileName) Then
        DeleteIniSection = True
Else
        MsgBox "Error deleting section from .ini file: " _
            & err.LastDllError
        DeleteIniSection = False
End If

End Function

Function DeleteIniKey(strSection As String, _
                      strKey As String, _
                      strFileName As String) As Boolean

If WritePrivateProfileString(strSection, strKey, _
            vbNullString, strFileName) Then
        DeleteIniKey = True
Else
        MsgBox "Error deleting section from .ini file: " _
            & err.LastDllError
        DeleteIniKey = False
End If

End Function

Function ReadFromIniFile( _
   ByVal strFileName As String, _
   ByVal strSection As String, _
   ByVal strKey As String, _
   Optional ByVal strDefault As String = "" _
   ) As String
    
Dim strValue As String
    
'Fill string buffer with null characters.
strValue = String$(255, vbNullChar)
    
'attempt to read value. GetPrivateProfileString
'function returns number of characters written
'into string.
If GetPrivateProfileString(strSection, strKey, _
            strDefault, strValue, Len(strValue), _
            strFileName) > 0 Then

'parse the string and return
strValue = Left(strValue, InStr(strValue, vbNullChar) - 1)
        ReadFromIniFile = strValue
Else
        ReadFromIniFile = strDefault
End If

End Function
